<?php
namespace bwdsiax_ScrollingIconAnimation_namespace;

use bwdsiax_ScrollingIconAnimation_namespace\PageSettings\Page_Settings;
define( "BWDSIAX_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "BWDSIAX_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdsiaxeffective {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdsiax_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdsiax_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdsiax_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdsiax_effective_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdsiax-scrolling-icon-animation-widget.php' );
	}

	public function bwdsiax_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdsiax_ScrollingIconAnimation_widgets());
	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/bwdsiax-scrolling-icon-animation-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function bwdsiax_add_elementor_widget_categories( $elements_manager ) {
		$elements_manager->add_category(
			'bwdsiax-scrolling-icon-animation-category',
			[
				'title' => esc_html__( 'Trigger Lottie Animation', 'bwdsiax-icon-animation' ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdsiax_all_assets_for_the_public(){

		wp_enqueue_script( 'bwdsiax-ScrollIconAnimation-main', plugin_dir_url( __FILE__ ) . 'assets/public/js/icon.js', array('jquery'), '1.3', true );
		wp_enqueue_script( 'bwdsiax-ScrollIconAnimation-main-min', plugin_dir_url( __FILE__ ) . 'assets/public/js/icon.min.js', array('jquery'), '1.3', true );

		$all_css_file = array(
			'bwdsiax-ScrollIconAnimation-plugin-main' => array('bwdsiax_ScrollIconAnimation_css_path_define'=>BWDSIAX_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),
        );
        foreach($all_css_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdsiax_ScrollIconAnimation_css_path_define'], null, '1.3', 'all');
        }

	}

	//admin-icon
	public function bwdsiax_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
			'bwdsiax-admin-main' => array('bwdsiax_path_admin_define'=>BWDSIAX_ASFSK_ASSETS_ADMIN_DIR_FILE . '/icon.css'),
		);
		foreach($all_css_js_file as $handle => $fileinfo){
			wp_enqueue_style( $handle, $fileinfo['bwdsiax_path_admin_define'], null, '1.0', 'all');
		}
	}
	
	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdsiax_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdsiax_all_assets_for_elementor_editor_admin']);
		
		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdsiax_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdsiax_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdsiax_admin_editor_scripts' ] );
		
		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
Classbwdsiaxeffective::instance();